<template>
  <div class="toggle-input">
    <input 
      class="toggle-input__box"
      type="checkbox"
      v-model="$parent[model]"
    />
    <span class="toggle-input__slider-background" />
    <span class="toggle-input__slider-ball" /> 
    <label class="toggle-input__label"> {{ label }} </label>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    label: {
      type: String,
      required: true,
    },
    model: {
      type: String,
      required: true,
    },
  },
});
</script>


<style lang="postcss">
.toggle-input {
  @apply relative m-4;
}

.toggle-input__box {
  @apply absolute opacity-0 cursor-pointer h-full;

  z-index: 2;
  width: 2.5rem;
}

.toggle-input__slider-background {
  @apply absolute inline-block cursor-pointer pin bg-grey rounded-full;

  width: 2.5rem;
  height: 1.3rem;

  transition: all 0.4s ease-out;
}

.toggle-input__slider-ball {
  @apply absolute bg-white rounded-full;

  left: 2pt;
  top: 10%;

  height: 1rem;
  width: 1rem;

  transition: all 0.4s ease-out;
}

.toggle-input__label {
  @apply ml-12;
}

.toggle-input__box:checked ~ .toggle-input__slider-background {
  @apply bg-primary
}

.toggle-input__box:checked ~ .toggle-input__slider-ball {
  transform: translateX(calc(1.5rem - 4pt));
}
</style>
